Attribute VB_Name = "modMF"
Option Explicit

' ----==== Const ====----
Public Const S_OK As Long = &H0&
Public Const API_True As Long = &H1&
Public Const CC_STDCALL As Long = &H4&
Public Const IID_Release As Long = &H8&
Public Const FILE_END As Long = &H2&
Public Const OPEN_EXISTING As Long = &H3&
Public Const FILE_SHARE_READ As Long = &H1&
Public Const GENERIC_WRITE As Long = &H40000000
Public Const FILE_FLAG_SEQUENTIAL_SCAN As Long = &H8000000
Public Const INVALID_SET_FILE_POINTER As Long = &HFFFFFFFF

Public Const MF_STARTUP_FULL As Long = &H0&
Public Const MF_VERSION As Long = &H1& ' &H2&

Public Const MF_PD_DURATION As String = "{6c990d33-bb8e-477a-8598-0d5d96fcd88a}"

Public Const MF_SOURCE_READER_FIRST_AUDIO_STREAM As Long = &HFFFFFFFD
Public Const MF_SOURCE_READER_MEDIASOURCE As Long = &HFFFFFFFF

Public Const MF_MT_MAJOR_TYPE As String = "{48EBA18E-F8C9-4687-BF11-0A74C9F96A8F}"
Public Const MF_MT_SUBTYPE As String = "{F7E34C9A-42E8-4714-B74B-CB29D72C35E5}"

Public Const MFMediaType_Audio As String = "{73647561-0000-0010-8000-00AA00389B71}"
Public Const MFAudioFormat_PCM As String = "{00000001-0000-0010-8000-00aa00389b71}"

Public Const MF_MT_AUDIO_SAMPLES_PER_SECOND As String = "{5faeeae7-0290-4c31-9e8a-c534f68d9dba}"
Public Const MF_MT_AUDIO_BITS_PER_SAMPLE As String = "{f2deb57f-40fa-4764-aa33-ed4f2d1ff669}"
Public Const MF_MT_AUDIO_NUM_CHANNELS As String = "{37e48bf5-645e-4c5b-89de-ada9e29b696a}"
Public Const MF_MT_AUDIO_BLOCK_ALIGNMENT As String = "{322de230-9eeb-43bd-ab7a-ff412251541d}"
Public Const MF_MT_AUDIO_AVG_BYTES_PER_SECOND As String = "{1aab75c8-cfef-451c-ab95-ac034b8e1731}"
Public Const MF_MT_ALL_SAMPLES_INDEPENDENT As String = "{c9173739-5e56-461c-b713-46fb995cb95f}"

' ----==== Enums ====----
Public Enum vtb_Interfaces
    
    ' IMFByteStream
    GetLength_BS = 4
    SetCurrentPosition_BS = 7
    Read_BS = 9
    Write_BS = 12
    Flush_BS = 16
    Close_BS = 17
    
    'IMFSourceReader
    SetCurrentMediaType = 7
    ReadSample = 9
    GetPresentationAttribute = 12
    
    ' IMFMediaType
    SetUINT32 = 21
    SetGUID = 24
    
    ' IMFMediaSink
    GetStreamSinkCount = 6
    GetStreamSinkByIndex = 7
    Shutdown = 11
    
    ' IMFStreamSink
    ProcessSample = 10
    Flush_SS = 12
    
    'IMFSample
    GetSampleDuration_S = 37
    
    ' IStream
    Read_Strm = 3
    Write_Strm = 4
    Seek_Strm = 5
    CopyTo_Strm = 7
    
End Enum

Public Enum MF_SOURCE_READER_FLAG
    MF_SOURCE_READERF_ERROR = &H1&
    MF_SOURCE_READERF_ENDOFSTREAM = &H2&
    MF_SOURCE_READERF_NEWSTREAM = &H4&
    MF_SOURCE_READERF_NATIVEMEDIATYPECHANGED = &H10&
    MF_SOURCE_READERF_CURRENTMEDIATYPECHANGED = &H20&
    MF_SOURCE_READERF_STREAMTICK = &H100&
    MF_SOURCE_READERF_ALLEFFECTSREMOVED = &H200&
End Enum

Public Enum MF_FILE_ACCESSMODE
    MF_ACCESSMODE_READ = &H1&
    MF_ACCESSMODE_WRITE = &H2&
    MF_ACCESSMODE_READWRITE = &H3&
End Enum

Public Enum MF_FILE_OPENMODE
    MF_OPENMODE_FAIL_IF_NOT_EXIST = &H0&
    MF_OPENMODE_FAIL_IF_EXIST = &H1&
    MF_OPENMODE_RESET_IF_EXIST = &H2&
    MF_OPENMODE_APPEND_IF_EXIST = &H3&
    MF_OPENMODE_DELETE_IF_EXIST = &H4&
End Enum

Public Enum MF_FILE_FLAGS
    MF_FILEFLAGS_NONE = &H0&
    MF_FILEFLAGS_NOBUFFERING = &H1&
    MF_FILEFLAGS_ALLOW_WRITE_SHARING = &H2&
End Enum

Public Enum STGM
    STGM_FAILIFTHERE = &H0
    STGM_DIRECT = &H0
    STGM_READ = &H0
    STGM_WRITE = &H1
    STGM_READWRITE = &H2
    STGM_SHARE_EXCLUSIVE = &H10
    STGM_SHARE_DENY_WRITE = &H20
    STGM_SHARE_DENY_READ = &H30
    STGM_SHARE_DENY_NONE = &H40
    STGM_CREATE = &H1000
    STGM_TRANSACTED = &H10000
    STGM_CONVERT = &H20000
    STGM_PRIORITY = &H40000
    STGM_NOSCRATCH = &H100000
    STGM_NOSNAPSHOT = &H200000
    STGM_DIRECT_SWMR = &H400000
    STGM_SIMPLE = &H8000000
    STGM_DELETEONRELEASE = &H4000000
End Enum

Public Enum STREAM_SEEK
    STREAM_SEEK_SET = &H0
    STREAM_SEEK_CUR = &H1
    STREAM_SEEK_END = &H2
End Enum

' ----==== Type ====----
Public Type GUID
    data1 As Long
    data2 As Integer
    data3 As Integer
    data4(0 To 7) As Byte
End Type

Public Type PROPVARIANT
    vt As Integer
    wReserved1 As Integer
    wReserved2 As Integer
    wReserved3 As Integer
    vData As Long
    Padding As Long
End Type

Public Type WaveHeader
    lRiff As Long
    lFileSize As Long
    lWave As Long
    lFmt As Long
    lFmtSize As Long
    iFormatTag As Integer
    iChannels As Integer
    lSamplesPerSec As Long
    lAvgBytesPerSec As Long
    iBlockAlign As Integer
    iBitsPerSample As Integer
    lData As Long
    lDataSize As Long
End Type

' ----==== Kernel32 API-Deklarationen ====----
Public Declare Sub CopyMemory Lib "kernel32.dll" _
                   Alias "RtlMoveMemory" ( _
                   ByRef pTo As Any, _
                   ByRef uFrom As Any, _
                   ByVal lSize As Long)

Public Declare Function CreateFile Lib "kernel32.dll" _
                        Alias "CreateFileW" ( _
                        ByVal lpFileName As Long, _
                        ByVal dwDesiredAccess As Long, _
                        ByVal dwShareMode As Long, _
                        ByVal lpSecurityAttributes As Long, _
                        ByVal dwCreationDisposition As Long, _
                        ByVal dwFlagsAndAttributes As Long, _
                        ByVal hTemplateFile As Long) As Long

Public Declare Function SetFilePointer Lib "kernel32.dll" ( _
                        ByVal hFile As Long, _
                        ByVal lDistanceToMove As Long, _
                        ByVal lpDistanceToMoveHigh As Long, _
                        ByVal dwMoveMethod As Long) As Long

Public Declare Function SetEndOfFile Lib "kernel32" ( _
                        ByVal hFile As Long) As Long

Public Declare Function CloseHandle Lib "kernel32.dll" ( _
                        ByVal hObject As Long) As Long

' ----==== Shlwapi API-Deklarationen ====----
Public Declare Function SHCreateStreamOnFileEx Lib "shlwapi.dll" ( _
                        ByVal pszFile As Long, _
                        ByVal grfMode As STGM, _
                        ByVal dwAttributes As Long, _
                        ByVal fCreate As Long, _
                        ByVal pstmTemplate As Long, _
                        ByRef ppstm As Long) As Long

' ----==== Oleaut32.dll Deklarationen ====----
Public Declare Function DispCallFunc Lib "Oleaut32.dll" ( _
                        ByVal pvInstance As Long, _
                        ByVal oVft As Long, _
                        ByVal cc As Long, _
                        ByVal vtReturn As VbVarType, _
                        ByVal cActuals As Long, _
                        ByVal prgvt As Any, _
                        ByVal prgpvarg As Any, _
                        ByRef pvargResult As Variant) As Long

' ----==== Ole32 API-Deklarationen ====----
Public Declare Function CLSIDFromString Lib "Ole32.dll" ( _
                        ByVal pString As Long, _
                        ByRef pCLSID As GUID) As Long

Public Declare Function PropVariantClear Lib "Ole32.dll" ( _
                        ByRef pVar As PROPVARIANT) As Long

' ----==== Propsys.dll Deklarationen ====----
Public Declare Function PropVariantToInt64 Lib "Propsys.dll" ( _
                        ByRef propvarIn As PROPVARIANT, _
                        ByRef pllRet As Currency) As Long

' ----==== Mfplat.dll Deklarationen ====----
Public Declare Function MFStartup Lib "Mfplat.dll" ( _
                        ByVal Version As Long, _
                        ByVal dwFlags As Long) As Long

Public Declare Function MFShutdown Lib "Mfplat.dll" () As Long

Public Declare Function MFCreateFile Lib "Mfplat.dll" ( _
                        ByVal AccessMode As MF_FILE_ACCESSMODE, _
                        ByVal OpenMode As MF_FILE_OPENMODE, _
                        ByVal fFlags As MF_FILE_FLAGS, _
                        ByVal pwszFileURL As Long, _
                        ByRef ppIByteStream As Long) As Long

Public Declare Function MFCreateMediaType Lib "Mfplat.dll" ( _
                        ByRef ppMFType As Long) As Long

' ----==== Mfreadwrite.dll Deklarationen ====----
Public Declare Function MFCreateSourceReaderFromURL Lib "Mfreadwrite.dll" ( _
                        ByVal pwszURL As Long, _
                        ByVal pAttributes As Long, _
                        ByRef ppSourceReader As Long) As Long

' ----==== Mfsrcsnk.dll Deklarationen ====----
Public Declare Function MFCreateWAVEMediaSink Lib "Mfsrcsnk.dll" ( _
                        ByVal pTargetByteStream As Long, _
                        ByVal pAudioMediaType As Long, _
                        ByRef ppMediaSink As Long) As Long

' ----==== Call OleInvoke ====----
Public Function Invoke(ByVal pInterface As Long, ByVal vtb As vtb_Interfaces, _
    ParamArray var()) As Variant
    
    If pInterface <> 0& Then
    
        Invoke = OleInvoke(pInterface, vtb, var)
        
    End If
    
End Function

' ----==== Release Interface ====----
Public Sub Release(ByRef pInterface As Long)

    Dim vRet As Variant

    ' ist ein Pointer auf ein Interfac vorhanden
    If pInterface <> 0& Then

        ' Funktion Release des Interfaces aufrufen
        If DispCallFunc(pInterface, IID_Release, CC_STDCALL, vbLong, _
            0&, 0&, 0&, vRet) = S_OK Then

            pInterface = 0&

        End If

    End If

End Sub

' ----==== Call Interface Function ====----
Private Function OleInvoke(ByVal pInterface As Long, ByVal lCmd As Long, _
    ParamArray aParam()) As Variant
    
    Dim lItem As Long
    Dim lCount As Long
    Dim vRet As Variant
    Dim vParam As Variant
    Dim olePtr(10) As Long
    Dim oleTyp(10) As Integer

    ' wenn ein Pointer auf ein Interface vorhanden ist
    If pInterface <> 0& Then

        ' nur wenn zum Aufruf der Interface-Funktion auch
        ' Parameter vorhanden sind.
        If UBound(aParam) >= 0 Then

            ' ParamArray nach Variant
            vParam = aParam

            ' ist der Variant ein Array
            If IsArray(vParam) Then vParam = vParam(0)

            ' Anzahl der Parameter
            lCount = UBound(vParam)

            ' alle Parameter durchlaufen
            For lItem = 0 To lCount

                ' Typ des Parameter
                oleTyp(lItem) = VarType(vParam(lItem))

                ' Pointer auf den Parameter
                olePtr(lItem) = VarPtr(vParam(lItem))

            Next

        End If

        ' Funktion des Interfaces aufrufen
        If DispCallFunc(pInterface, lCmd * 4, CC_STDCALL, vbLong, _
            lItem, VarPtr(oleTyp(0)), VarPtr(olePtr(0)), vRet) <> S_OK Then
            
            Debug.Print "Fehler beim Aufrufen der Interface-Funktion!"

        End If

    End If

    OleInvoke = vRet

End Function

' ----==== String -> GUID ====----
Public Function Str2Guid(ByVal str As String) As GUID

    Call CLSIDFromString(StrPtr(str), Str2Guid)
    
End Function

